Index: doc/aubiocut.sgml
===================================================================
--- doc/aubiocut.sgml	(revision beea3cfad02b018a96c83874f871cd152a48c1e6)
+++ doc/aubiocut.sgml	(revision 823fa09ce5dedcdeb7f314a957fcc162884c957d)
@@ -69,11 +69,4 @@
     <title>DESCRIPTION</title>
 
-    <para>This manual page documents briefly the <command>&dhpackage;</command> command.</para>
-
-    <para>The <emphasis>aubio</emphasis> library provides a small set of
-    functions to extract events and objects from audio, from live streams or
-    still files. Onsets are used to label the beginning of notes, pitches to
-    label their height.</para>
-
     <para><command>&dhpackage;</command> attempts to detect onset times, the
     beginning of discreted sound events, or beat locations, in audio
Index: doc/aubionotes.sgml
===================================================================
--- doc/aubionotes.sgml	(revision beea3cfad02b018a96c83874f871cd152a48c1e6)
+++ doc/aubionotes.sgml	(revision 823fa09ce5dedcdeb7f314a957fcc162884c957d)
@@ -69,11 +69,4 @@
     <title>DESCRIPTION</title>
 
-    <para>This manual page documents briefly the <command>&dhpackage;</command> command.</para>
-
-    <para>The <emphasis>aubio</emphasis> library provides a small set of
-    functions to extract events and objects from audio, from live streams or
-    still files. Onsets are used to label the beginning of notes, pitches to
-    label their height.</para>
-
     <para><command>&dhpackage;</command> attempts to detect notes in audio
     signals, segmenting consecutive events using onset detection, and
Index: doc/aubioonset.sgml
===================================================================
--- doc/aubioonset.sgml	(revision beea3cfad02b018a96c83874f871cd152a48c1e6)
+++ doc/aubioonset.sgml	(revision 823fa09ce5dedcdeb7f314a957fcc162884c957d)
@@ -69,11 +69,4 @@
     <title>DESCRIPTION</title>
 
-    <para>This manual page documents briefly the <command>&dhpackage;</command> command.</para>
-
-    <para>The <emphasis>aubio</emphasis> library provides a small set of
-    functions to extract events and objects from audio, from live streams or
-    still files. Onsets are used to label the beginning of notes, pitches to
-    label their height.</para>
-
     <para><command>&dhpackage;</command> attempts to detect onset times, the
     beginning of discreted sound events, in audio signals.</para>
Index: doc/aubiopitch.sgml
===================================================================
--- doc/aubiopitch.sgml	(revision beea3cfad02b018a96c83874f871cd152a48c1e6)
+++ doc/aubiopitch.sgml	(revision 823fa09ce5dedcdeb7f314a957fcc162884c957d)
@@ -69,11 +69,4 @@
     <title>DESCRIPTION</title>
 
-    <para>This manual page documents briefly the <command>&dhpackage;</command> command.</para>
-
-    <para>The <emphasis>aubio</emphasis> library provides a small set of
-    functions to extract events and objects from audio, from live streams or
-    still files. Onsets are used to label the beginning of notes, pitches to
-    label their height.</para>
-
     <para><command>&dhpackage;</command> attempts to extract fundamental
     frequency in sound files. When no pitch candidate is found, the output is
Index: doc/aubiotrack.sgml
===================================================================
--- doc/aubiotrack.sgml	(revision beea3cfad02b018a96c83874f871cd152a48c1e6)
+++ doc/aubiotrack.sgml	(revision 823fa09ce5dedcdeb7f314a957fcc162884c957d)
@@ -69,11 +69,4 @@
     <title>DESCRIPTION</title>
 
-    <para>This manual page documents briefly the <command>&dhpackage;</command> command.</para>
-
-    <para>The <emphasis>aubio</emphasis> library provides a small set of
-    functions to extract events and objects from audio, from live streams or
-    still files. Onsets are used to label the beginning of notes, pitches to
-    label their height.</para>
-
     <para><command>&dhpackage;</command> attempts to tap the beat and detect
     beat locations in musical sounds. When started with an input file argument